# window.py
#
# Copyright 2023 Late Night Defender
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-3.0-or-later

from gi.repository import Adw
from gi.repository import Gtk

@Gtk.Template(resource_path='/org/techtransthai/Count/window.ui')
class CountWindow(Adw.ApplicationWindow):
    __gtype_name__ = 'CountWindow'

    calculate_button = Gtk.Template.Child()
    clear_button = Gtk.Template.Child()
    inputdata = Gtk.Template.Child()
    rank_output = Gtk.Template.Child()
    zero_output = Gtk.Template.Child()
    zerop_output = Gtk.Template.Child()
    one_output = Gtk.Template.Child()
    onep_output = Gtk.Template.Child()
    two_output = Gtk.Template.Child()
    twop_output = Gtk.Template.Child()
    three_output = Gtk.Template.Child()
    threep_output = Gtk.Template.Child()
    four_output = Gtk.Template.Child()
    fourp_output = Gtk.Template.Child()
    five_output = Gtk.Template.Child()
    fivep_output = Gtk.Template.Child()
    six_output = Gtk.Template.Child()
    sixp_output = Gtk.Template.Child()
    seven_output = Gtk.Template.Child()
    sevenp_output = Gtk.Template.Child()
    eight_output = Gtk.Template.Child()
    eightp_output = Gtk.Template.Child()
    nine_output = Gtk.Template.Child()
    ninep_output = Gtk.Template.Child()

    def __init__(self, **kwargs):
        super().__init__(**kwargs)
        self.calculate_button.connect('clicked', self.calculate_clicked)
        self.clear_button.connect('clicked', self.clear_clicked)

    def clear_clicked(self, btnobj):
        self.inputdata.set_text("",0)

    def calculate_clicked(self, btnobj):
        userInput = self.inputdata.get_text(self.inputdata.get_start_iter(),self.inputdata.get_end_iter(),False)
        zero,one,two,three,four,five,six,seven,eight,nine=0,0,0,0,0,0,0,0,0,0

        for i in userInput:
            if i=="0":
                zero+=1
            elif i=="1":
                one+=1
            elif i=="2":
                two+=1
            elif i=="3":
                three+=1
            elif i=="4":
                four+=1
            elif i=="5":
                five+=1
            elif i=="6":
                six+=1
            elif i=="7":
                seven+=1
            elif i=="8":
                eight+=1
            elif i=="9":
                nine+=1

        actualLength = one+two+three+four+five+six+seven+eight+nine+zero
        print(actualLength)

        self.zero_output.set_text(str(zero),-1)
        self.zerop_output.set_text("{0:.4}".format(zero/actualLength*100),-1)
        self.one_output.set_text(str(one),-1)
        self.onep_output.set_text("{0:.4}".format(one/actualLength*100),-1)
        self.two_output.set_text(str(two),-1)
        self.twop_output.set_text("{0:.4}".format(two/actualLength*100),-1)
        self.three_output.set_text(str(three),-1)
        self.threep_output.set_text("{0:.4}".format(three/actualLength*100),-1)
        self.four_output.set_text(str(four),-1)
        self.fourp_output.set_text("{0:.4}".format(four/actualLength*100),-1)
        self.five_output.set_text(str(five),-1)
        self.fivep_output.set_text("{0:.4}".format(five/actualLength*100),-1)
        self.six_output.set_text(str(six),-1)
        self.sixp_output.set_text("{0:.4}".format(six/actualLength*100),-1)
        self.seven_output.set_text(str(seven),-1)
        self.sevenp_output.set_text("{0:.4}".format(seven/actualLength*100),-1)
        self.eight_output.set_text(str(eight),-1)
        self.eightp_output.set_text("{0:.4}".format(eight/actualLength*100),-1)
        self.nine_output.set_text(str(nine),-1)
        self.ninep_output.set_text("{0:.4}".format(nine/actualLength*100),-1)

        rank=[zero,one,two,three,four,five,six,seven,eight,nine]
        rankNumber = ""
        for j in range(10):
            most = -1
            mostIndex = -1
            for i in range(10):
                if rank[i]>most:
                    most=rank[i]
                    mostIndex=i
            rankNumber += str(mostIndex)
            rank[mostIndex]=-1
        self.rank_output.set_text(rankNumber,-1)

